#import "MiniSQLExpression.h"

#import <eoaccess/eoaccess.h>

#import <foundation/NSUtilities.h>
#import <foundation/NSCharacterSet.h>

@implementation MiniSQLExpression:EOSQLExpression

- whereClauseForQualifier:(EOQualifier *) qualifier
    joinExpresssion:joinExpression
 // Builds an SQL WHERE clause using the qualifier and joinExpression 
{
    NSRange rangeOpen;
    NSRange rangeClose;

    NSMutableString    *newExpression =
	[NSMutableString stringWithCapacity:80];

    NSMutableString    *newQualification =
	[[qualifier expressionValueForContext:self] mutableCopy];

    NSMutableString    *newJoinExpression =
	[[joinExpression expressionValueForContext:self] mutableCopy];

    if (qualifier) {
	while ((rangeOpen = [newQualification rangeOfString:@"("]).length != 0) {
	    [newQualification deleteCharactersInRange:rangeOpen];
	}
	while ((rangeClose = [newQualification rangeOfString:@")"]).length != 0) {
	    [newQualification deleteCharactersInRange:rangeClose];
	}
	[newExpression appendString:newQualification];
    }
    if (joinExpression) {
	while ((rangeOpen = [newJoinExpression rangeOfString:@"("]).length != 0) {
	    [newJoinExpression deleteCharactersInRange:rangeOpen];
	}
	while ((rangeClose = [newJoinExpression rangeOfString:@")"]).length != 0) {
	    [newJoinExpression deleteCharactersInRange:rangeClose];
	}
	if ([newQualification length] > 0) {
	    [newExpression appendString:@" AND "];
	}
	[newExpression appendString:newJoinExpression];
    }
    if ([newExpression length] > 0) {
	return[NSString stringWithFormat:@"WHERE %@", newExpression];
    } else {
	return @"";
    }
}

@end

